﻿using System;
using System.ComponentModel;
using System.Windows.Forms;

namespace BrowsableAttribChange
{
    public partial class Form1 : Form
    {
        User usr;
        AttributesProxyTypeDescriptor proxy;
        public Form1()
        {
            InitializeComponent();
            usr = new User();
            proxy = new AttributesProxyTypeDescriptor(usr); 
            propertyGrid1.SelectedObject = proxy;
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            proxy.BrowsableAttributeAlwaysTrue = checkBox1.Checked;
            propertyGrid1.Refresh();
        }
    }
    public class User
    {
        [BrowsableAttribute(true)]
        public string Name { get; set; }
        [BrowsableAttribute(false)]
        public string SecondName { get; set; }
    }

}
